
# charged player
#execute as @a[scores={nbenergy=1..}] at @s run function nbauto:chargedplayer
#execute as @s[scores={nbenergyneeded=1..}] run scoreboard players remove @s nbenergyneeded 10

# teleporter config

scoreboard players enable @a TeleporterId
execute as @a at @s unless score @s TeleporterId matches 0 run scoreboard players operation @n[type=text_display,tag=teleporter,distance=..5] nbteleporterid = @s TeleporterId
execute as @a at @s unless score @s TeleporterId matches 0 as @n[type=text_display,tag=teleporter,distance=..5] run function nbauto:teleporter/updateid
execute as @a unless score @s TeleporterId matches 0 run scoreboard players set @s TeleporterId 0

# teleporter basic stuff

execute as @e[type=item,nbt={Item:{id:"minecraft:ender_pearl",count:1}}] at @s if block ~ ~-1 ~ crying_obsidian align xyz run function nbauto:teleporter/create
execute as @e[type=text_display,tag=teleporter] at @s run function nbauto:teleporter/checkduplicate
execute as @e[type=text_display,tag=teleporter] at @s unless block ~ ~ ~ crying_obsidian run function nbauto:teleporter/destroy

# teleporter unique behavior
execute as @e[type=text_display,tag=teleporter,scores={nbenergy=100..}] at @s if entity @p[scores={teleportcooldown=0..},distance=..2,predicate=nbauto:sneaking] run function nbauto:teleporter/teleport


# quarry comming soon
# stonecutter + diamond pick = quarry
# on right click of the stone cutter's top you will get an item that will determine where the quarry will mine
# once area is set you can give the quarry power to start excavation
# if you right click when the quarry already has a specified area it will give a visual indicator of the area
# if left clicked it will reset its mining area
# Idk if this will happen but it might be able to chunck load its mining area until it is finished but that seems a bit difficult
# when the quarry is done it will forget it's mining area

execute as @e[type=item,nbt={Item:{id:"minecraft:diamond_pickaxe",count:1}}] at @s if block ~ ~ ~ stonecutter align xyz run function nbauto:quarry/place
execute as @e[type=item_display,tag=quarry] at @s run function nbauto:quarry/checkduplicate
execute as @e[type=item_display,tag=quarry] at @s unless block ~ ~ ~ stonecutter run function nbauto:quarry/destroy
# quarry unique behavior
execute as @a[nbt=!{Inventory:[{components:{"minecraft:custom_data":{QuarrySetter:1}}}]}] at @s if entity @e[type=item_display,tag=quarry,scores={nbQuarrySet=0},distance=..1,limit=1] run function nbauto:quarry/giveposset1
execute as @e[type=item_display,tag=quarry,scores={nbQuarrySet=1}] if score @s nbenergyneeded <= @s nbenergy at @s run function nbauto:quarry/startmining
execute as @e[type=item_display,tag=quarry,scores={nbQuarrySet=1}] if score @s nbenergyneeded > @s nbenergy at @s run title @a[distance=...5] actionbar [{"text":"Energy: "},{"score":{"name":"@s","objective":"nbenergy"}},{"text":" / "},{"score":{"name":"@s","objective":"nbenergyneeded"}}]
execute as @e[type=item_display,tag=quarry,scores={nbQuarrySet=0}] at @s run title @a[distance=...5] actionbar [{"text":"Energy: "},{"score":{"name":"@s","objective":"nbenergy"}}]

kill @e[type=block_display,tag=quarryareavisual]
execute as @a[predicate=nbauto:quarrytweak] at @s run function nbauto:quarry/tweakarea/main

#quarry miner entity
execute as @e[type=armor_stand,tag=quarryminer,limit=10,sort=random] at @s run function nbauto:quarry/miner/main


# next function

schedule function nbauto:20tick-1 5t